# EducBot
Un petit bot d'éduc pop pour Discord (WIP).
Il permet de voir qui secoue les mains dans une discussion vocale.

## Contribuer
Pour donner votre avis, proposer une modification ou amélioration, contactez nous via le [formulaire de Jean-Cloud](https://jean-cloud.net#contact)

Pour proposer une modification, n’hésitez pas à faire une pull request !


## Utilisation
### Installer le bot dans le serveur Discord
Ce n’est pour l’instant pas forcement facile…

### Fonctionnement
EducBot écoute tous les messages d’un serveur où il a été installé (comme tous les bots).
Il réagira a des commandes messages commençants par `!`, et a des mots clef.

EducBot a pour objectif de recenser les utilisateurs souhaitant réagir.

#### Les commandes
EducBot répondra en toutes circonstances (sauf serveur cassé) aux commandes suivantes :
- `!educpop-help` Listera ces commandes
- `!educpop-enable` Commence la comptabilisation
- `!educpop-disable` Stope la comptabilisation
- `!educpop-reset` Remet à zéro les compteurs
- `!educpop-pause` Pause la comptabilisation
- `!educpop-resume` Reprend la comptabilisation
- `!educpop-list` Liste les mots-clés qui sont comptabilisés

Par exemple, taper `!educpop-list` dans un canal texte **où EducBot est activé**, lui fait dire :
```
Tapez simplement le mot-clé ci-dessous pour être comptabilisé. Tapez un - immédiatement suivi du mot-clé pour être retiré du compte : -oui par exemple !
:thumbsup:oui : Je suis d’accord
:thumbsdown:non : Je ne suis pas d’accord
:raised_hand:parole : Je veux parler
:raised_hands:réponse : Je veux répondre rapidement
:octagonal_sign:suffit : On tourne en rond
:hear_no_evil:écoute : On ne s’écoute pas
:heart_eyes:love : J’adore
:dab:dab : Dab
```

#### Les mots-clés
Écrire seulement `oui` dans un canal texte **où EducBot est activé**, lui fait ajouter votre nom d’utilisateur dans la liste des gens d’accord.

Écrire seulement `-oui` fait retirer ce nom.

#### Visualisation
Le bot fait un résumé de l’état des compteurs à chaque changement.
Pour des raisons de visibilités, le message utilisateur et les anciens messages de résumé sont supprimés.

#### Interface web
Une interface web permet de suivre l’état des compteurs sans être secoué par un chat en folie.

## Lancer sa propre instance
Vu que le bot peut lire tous vos messages, il est normal de vouloir héberger sa propre instance !  
Il faut suivre la documentation discord pour la création d’un bot, récupérer un token de développeur et le mettre dans le fichier `.env`

## Développement
### Fichiers
- `index.js` est un module nodejs qui est le cœur du bot !
- `index.html` est la page html qui affiche les réactions des gens en temps réel
- `main.js` est le script qui fait tourner la page précédente
- `defaultReactions.json` est le fichier qui contient les réactions possibles par défaut

### Améliorations futures
#### Interface web
- Pouvoir supprimer des réactions / les reset (on y est presque)
- Avoir les emojis. Voir [twemoji](https://github.com/twitter/twemoji/tree/master/assets/svg). Il faut avoir leur code utf-truc.

#### Discord
- Faire une image docker
- La déployer et mettre le bot sur le serveur discord

